## ros-eloquent-mapviz-plugins 2.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

if (NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

project(mapviz_plugins)

# Ros Packages
find_package(ament_cmake REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(gps_msgs REQUIRED)
find_package(image_transport REQUIRED)
find_package(map_msgs REQUIRED)
find_package(mapviz REQUIRED)
find_package(marti_common_msgs REQUIRED)
find_package(marti_nav_msgs REQUIRED)
find_package(marti_sensor_msgs REQUIRED)
find_package(marti_visualization_msgs REQUIRED)
# find_package(move_base_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(stereo_msgs REQUIRED)
find_package(swri_image_util REQUIRED)
find_package(swri_math_util REQUIRED)
find_package(swri_route_util REQUIRED)
find_package(swri_transform_util REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(visualization_msgs REQUIRED)

### QT ###
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5OpenGL REQUIRED)
find_package(Qt5Widgets REQUIRED)
add_definitions(-DWFlags=WindowFlags)

find_package(OpenCV COMPONENTS core imgproc REQUIRED)

### OpenGL ###
if(${CMAKE_VERSION} VERSION_EQUAL "3.11.0" OR ${CMAKE_VERSION} VERSION_GREATER "3.11.0")
  cmake_policy(SET CMP0072 NEW)
endif()
find_package(OpenGL REQUIRED)
find_package(GLUT REQUIRED)

# Fix conflict between Boost signals used by tf and QT signals used by mapviz
add_definitions(-DQT_NO_KEYWORDS)

# Need to include the current dir to include the results of building Qt UI files
set(CMAKE_INCLUDE_CURRENT_DIR ON)
include_directories(include)
include_directories(SYSTEM
  ${OpenCV_INCLUDE_DIRS}
)

set(UI_FILES
    ui/attitude_indicator_config.ui
    ui/coordinate_picker_config.ui
    ui/disparity_config.ui
    ui/draw_polygon_config.ui
    ui/float_config.ui
    ui/gps_config.ui
    ui/grid_config.ui
    ui/image_config.ui
    ui/laserscan_config.ui
    ui/marker_config.ui
    ui/measuring_config.ui
    # ui/move_base_config.ui
    ui/navsat_config.ui
    ui/occupancy_grid_config.ui
    ui/odometry_config.ui
    ui/path_config.ui
    ui/plan_route_config.ui
    ui/point_click_publisher_config.ui
    ui/pointcloud2_config.ui
    ui/pose_config.ui
    ui/robot_image_config.ui
    ui/route_config.ui
    ui/string_config.ui
    ui/textured_marker_config.ui
    ui/tf_frame_config.ui
    ui/topic_select.ui
)

set(SRC_FILES
    src/attitude_indicator_plugin.cpp
    src/canvas_click_filter.cpp
    src/coordinate_picker_plugin.cpp
    src/disparity_plugin.cpp
    src/draw_polygon_plugin.cpp
    src/float_plugin.cpp
    src/gps_plugin.cpp
    src/grid_plugin.cpp
    src/image_plugin.cpp
    src/laserscan_plugin.cpp
    src/marker_plugin.cpp
    src/measuring_plugin.cpp 
    # src/move_base_plugin.cpp
    src/navsat_plugin.cpp
    src/occupancy_grid_plugin.cpp
    src/odometry_plugin.cpp 
    src/path_plugin.cpp
    src/placeable_window_proxy.cpp
    src/plan_route_plugin.cpp
    src/point_click_publisher_plugin.cpp
    src/pointcloud2_plugin.cpp
    src/point_drawing_plugin.cpp
    src/pose_plugin.cpp
    src/robot_image_plugin.cpp
    src/route_plugin.cpp
    src/string_plugin.cpp
    src/textured_marker_plugin.cpp
    src/tf_frame_plugin.cpp
)

set(HEADER_FILES
    include/${PROJECT_NAME}/attitude_indicator_plugin.h
    include/${PROJECT_NAME}/canvas_click_filter.h
    include/${PROJECT_NAME}/coordinate_picker_plugin.h
    include/${PROJECT_NAME}/disparity_plugin.h
    include/${PROJECT_NAME}/draw_polygon_plugin.h
    include/${PROJECT_NAME}/float_plugin.h
    include/${PROJECT_NAME}/gps_plugin.h
    include/${PROJECT_NAME}/grid_plugin.h
    include/${PROJECT_NAME}/image_plugin.h
    include/${PROJECT_NAME}/laserscan_plugin.h
    include/${PROJECT_NAME}/marker_plugin.h
    include/${PROJECT_NAME}/measuring_plugin.h
    # include/${PROJECT_NAME}/move_base_plugin.h
    include/${PROJECT_NAME}/navsat_plugin.h
    include/${PROJECT_NAME}/occupancy_grid_plugin.h
    include/${PROJECT_NAME}/odometry_plugin.h
    include/${PROJECT_NAME}/path_plugin.h
    include/${PROJECT_NAME}/placeable_window_proxy.h
    include/${PROJECT_NAME}/plan_route_plugin.h
    include/${PROJECT_NAME}/point_click_publisher_plugin.h
    include/${PROJECT_NAME}/pointcloud2_plugin.h
    include/${PROJECT_NAME}/point_drawing_plugin.h
    include/${PROJECT_NAME}/pose_plugin.h
    include/${PROJECT_NAME}/robot_image_plugin.h
    include/${PROJECT_NAME}/route_plugin.h
    include/${PROJECT_NAME}/string_plugin.h
    include/${PROJECT_NAME}/textured_marker_plugin.h
    include/${PROJECT_NAME}/tf_frame_plugin.h
)
    
qt5_wrap_ui(UI_SRC_FILES ${UI_FILES})
qt5_wrap_cpp(MOC_FILES ${HEADER_FILES})

add_library(${PROJECT_NAME} SHARED
    ${MOC_FILES}
    ${SRC_FILES}
    ${UI_SRC_FILES}
)
target_compile_definitions(${PROJECT_NAME} PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
ament_target_dependencies(${PROJECT_NAME}
    ament_cmake
    ament_index_cpp
    cv_bridge
    gps_msgs
    image_transport
    map_msgs
    mapviz
    marti_common_msgs
    marti_nav_msgs
    marti_sensor_msgs
    marti_visualization_msgs
    # move_base_msgs
    nav_msgs
    pluginlib
    rclcpp
    sensor_msgs
    std_msgs
    stereo_msgs
    swri_image_util
    swri_math_util
    swri_route_util
    swri_transform_util
    tf2
    tf2_geometry_msgs
    tf2_ros
    visualization_msgs
)
target_link_libraries(${PROJECT_NAME}
    Qt5::Core
    Qt5::Gui
    Qt5::OpenGL
    Qt5::Widgets
    ${GLU_LIBRARY}
    ${GLUT_LIBRARY}
    ${OpenCV_LIBS}
)

### Install the plugins ###

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
  FILES_MATCHING PATTERN "*.h"
)

install(TARGETS ${PROJECT_NAME}
  RUNTIME DESTINATION lib/${PROJECT_NAME}
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

pluginlib_export_plugin_description_file(mapviz mapviz_plugins.xml)

ament_export_dependencies(${RUNTIME_DEPS} Qt)
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_package()

=== debian/changelog ===
ros-eloquent-mapviz-plugins (2.1.0-1bionic) bionic; urgency=high

  * Constrain the minimum line and point marker sizes to be 1 pixel wide. (#704 <https://github.com/swri-robotics/mapviz/issues/704>)
  * ROS Foxy support (#695 <https://github.com/swri-robotics/mapviz/issues/695>)
  * Update the displayed distance continuously while moving a point.
  * Use higher precision in the coordinate picker for wgs84 (#692 <https://github.com/swri-robotics/mapviz/issues/692>)
  * Clear the namespace list after hitting the clear button. (#691 <https://github.com/swri-robotics/mapviz/issues/691>)
  * Contributors: Matt Grogan, Matthew, P. J. Reed, Marc Alban

 -- P. J. Reed <preed@swri.org>  Thu, 22 Oct 2020 05:00:00 -0000

ros-eloquent-mapviz-plugins (2.0.0-1bionic) bionic; urgency=high

  * Port mapviz to ROS 2 (#672 <https://github.com/swri-robotics/mapviz/issues/672>)
  * Contributors: Daniel D'Souza, Matthew Bries, Matthew Grogan, P. J. Reed, Jason Gassaway, John Reyes, Jacob Hassold, Kevin Nickels, Roger Strain

 -- P. J. Reed <preed@swri.org>  Wed, 13 May 2020 05:00:00 -0000

ros-eloquent-mapviz-plugins (1.2.0-1bionic) bionic; urgency=high

  * Add text to measuring plugin (#640 <https://github.com/swri-robotics/mapviz/issues/640>)
  * Add mapviz plug-in for PoseStamped messages. (#641 <https://github.com/swri-robotics/mapviz/issues/641>)
  * Fix occupancy grid to load color scheme from configuration. (#642 <https://github.com/swri-robotics/mapviz/issues/642>)
  * Restore GL_UNPACK_ALIGNMENT to 4 to prevent corruption of Qt font rendering. (#643 <https://github.com/swri-robotics/mapviz/issues/643>)
  * Add ability to show and hide markers by namespace (#636 <https://github.com/swri-robotics/mapviz/issues/636>)
  * Fixed layout of MeasuringPlugin (#633 <https://github.com/swri-robotics/mapviz/issues/633>)
  * Fixed marker plugin to use swri_transform_util to ensure wgs84 markers work properly (#635 <https://github.com/swri-robotics/mapviz/issues/635>)
  * Contributors: Arkady Shapkin, Marc Alban, Matthew, Matthew Grogan, agyoungs

 -- P. J. Reed <preed@swri.org>  Wed, 04 Sep 2019 05:00:00 -0000

ros-eloquent-mapviz-plugins (1.1.1-1bionic) bionic; urgency=high

  * Textured Marker Adjustments (#611 <https://github.com/swri-robotics/mapviz/issues/611>, #616 <https://github.com/swri-robotics/mapviz/issues/616>) (#625 <https://github.com/swri-robotics/mapviz/issues/625>)
  * fixed issue #623 <https://github.com/swri-robotics/mapviz/issues/623> by updating UI field to read "Draw Style:" (#624 <https://github.com/swri-robotics/mapviz/issues/624>)
  * Contributors: mattrich37

 -- P. J. Reed <preed@swri.org>  Fri, 17 May 2019 05:00:00 -0000

ros-eloquent-mapviz-plugins (1.1.0-1bionic) bionic; urgency=high

  * Improve MarkerPlugin (#603 <https://github.com/swri-robotics/mapviz/issues/603>)
    * Improved performance of MarkerPlugin::handleMarker()
    * Support Text marker alpha channel
    * Don't use QColor for glColor4f
    * Use marker namespace and id as markers map key
  * [mapviz_plugins/attitude_indicator] Minor refactoring and redundant logging removed (#617 <https://github.com/swri-robotics/mapviz/issues/617>)
  * 606 sequential measuring (#607 <https://github.com/swri-robotics/mapviz/issues/607>)
    * Moved distance calculation to trigger on release of mouse. Added case to prevent distance calculation while moving map.
    * Added vertices and lines between measurement points. Left click to add point. Right click to delete. Added color selection for points and clear button to ui.
    * Added cumulative distance measurements from multiple points
    * Fixed individual and cumulative distance measurements. Changed it to only measure distance between points and not from fixed origin and first point
    * Moved distance calculation into separate function which is called when deleting a point, adding a point, or rearranging points.
  * Add image size check to textured marker plugin to prevent crashes. (#613 <https://github.com/swri-robotics/mapviz/issues/613>)
    * Add image size check to textured marker plugin to prevent crashes.
  * Fixed typo in string (#608 <https://github.com/swri-robotics/mapviz/issues/608>)
  * 605 add reset button marker (#609 <https://github.com/swri-robotics/mapviz/issues/609>)
    * Added Clear all marker buttons, added case for clear all support to markers
  * Contributors: Arkady Shapkin, Matthew, jbdaniel18

 -- P. J. Reed <preed@swri.org>  Wed, 20 Feb 2019 06:00:00 -0000

ros-eloquent-mapviz-plugins (1.0.1-1bionic) bionic; urgency=high

  * Use shared tf manager in measuring_plugin (#604 <https://github.com/swri-robotics/mapviz/issues/604>)
  * Contributors: jgassaway

 -- P. J. Reed <preed@swri.org>  Fri, 25 Jan 2019 06:00:00 -0000

ros-eloquent-mapviz-plugins (1.0.0-1bionic) bionic; urgency=high

  * Sharing tf_manager_ between main app and plugins (#555 <https://github.com/swri-robotics/mapviz/issues/555>)
  * Fix potential segfault in pointcloud plug-in. (#602 <https://github.com/swri-robotics/mapviz/issues/602>)
  * Add Measuring Plugin (#598 <https://github.com/swri-robotics/mapviz/issues/598>)
  * Contributors: Davide Faconti, Marc Alban, Matthew

 -- P. J. Reed <preed@swri.org>  Wed, 23 Jan 2019 06:00:00 -0000

ros-eloquent-mapviz-plugins (0.3.0-1bionic) bionic; urgency=high

  * Merge all -devel branches into a single master branch
  * Don't transform laser scans twice (#544 <https://github.com/swri-robotics/mapviz/issues/544>)
  * Improving point_drawing plugins and bug fix of tf_plugin (#557 <https://github.com/swri-robotics/mapviz/issues/557>)
  * OpenGL rendering of PointClouds  (2X speedup) (#558 <https://github.com/swri-robotics/mapviz/issues/558>)
  * Occupancy grid (new plugin) (#568 <https://github.com/swri-robotics/mapviz/issues/568>)
  * Bug fix in image plugin (#563 <https://github.com/swri-robotics/mapviz/issues/563>)
  * Fix Indigo build, clean up warnings (#597 <https://github.com/swri-robotics/mapviz/issues/597>)


=== debian/control ===
Source: ros-eloquent-mapviz-plugins
Section: misc
Priority: optional
Maintainer: P. J. Reed <preed@swri.org>
Build-Depends: debhelper (>= 9.0.0), libqt5core5a, libqt5opengl5-dev, qt5-qmake, ros-eloquent-ament-cmake, ros-eloquent-ament-index-cpp, ros-eloquent-cv-bridge, ros-eloquent-gps-msgs, ros-eloquent-image-transport, ros-eloquent-map-msgs, ros-eloquent-mapviz, ros-eloquent-marti-common-msgs, ros-eloquent-marti-nav-msgs, ros-eloquent-marti-sensor-msgs, ros-eloquent-marti-visualization-msgs, ros-eloquent-nav-msgs, ros-eloquent-pluginlib, ros-eloquent-rclcpp, ros-eloquent-rclcpp-action, ros-eloquent-sensor-msgs, ros-eloquent-std-msgs, ros-eloquent-stereo-msgs, ros-eloquent-swri-image-util, ros-eloquent-swri-math-util, ros-eloquent-swri-route-util, ros-eloquent-swri-transform-util, ros-eloquent-tf2, ros-eloquent-visualization-msgs, ros-eloquent-ros-workspace
Homepage: https://github.com/swri-robotics/mapviz
Standards-Version: 3.9.2

Package: ros-eloquent-mapviz-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5core5a, libqt5opengl5, ros-eloquent-ament-index-cpp, ros-eloquent-cv-bridge, ros-eloquent-gps-msgs, ros-eloquent-image-transport, ros-eloquent-map-msgs, ros-eloquent-mapviz, ros-eloquent-marti-common-msgs, ros-eloquent-marti-nav-msgs, ros-eloquent-marti-sensor-msgs, ros-eloquent-marti-visualization-msgs, ros-eloquent-nav-msgs, ros-eloquent-pluginlib, ros-eloquent-rclcpp, ros-eloquent-rclcpp-action, ros-eloquent-sensor-msgs, ros-eloquent-std-msgs, ros-eloquent-stereo-msgs, ros-eloquent-swri-image-util, ros-eloquent-swri-math-util, ros-eloquent-swri-route-util, ros-eloquent-swri-transform-util, ros-eloquent-tf2, ros-eloquent-visualization-msgs, ros-eloquent-ros-workspace
Description: Common plugins for the Mapviz visualization tool

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent" \
		-DCMAKE_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-mapviz-plugins//opt/ros/eloquent/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
